;This software is provided 'as-is', i.e. there's no guarantee it'll work for 
;any given application nor be a solution for any given problem.
;
;The software is public domain. Commercial & private use are explicitly allowed.
;If you use it for a commercial app feel free to tell me about it.
;
;Copyright by: Holger Apfel
;
;
;      Version 1 of a simple delay timer

	title ' Delay-timer'
	subtitle ' Version 0.99'

	processor 12C508
	__config b'01011'	; Code Protection off, MCLR on,
			; Watchdog off, ext. RC
;	cp:         PWFF	c: cal-mem, P: Prog-mem, R: res, W: WDT, F: Osz.
;	           -1---
;
;
;	GPIO,0:	Output Mosfet (Hi-Aktiv)
;	GPIO,1:	Output test: f = 1/32000 * t-low - as we're talking of long times ( min), it's quite nice to have some sort of faster timing control
;	GPIO,4:	Input Trigger ( Low = triggerung)
;	GPIO,5:	Clkin

;	LIST	P=PIC12C508

	include	p12C508.inc	; Register definitions
;	include	dev_fam.inc	; family-selection - not needed here

#define	counter	h'07'
#define	lowtime	7


	org	00

	bcf	STATUS,PA0
	movlw	b'11111000'
	option
	movlw	b'11111100'
	tris	GPIO

;	reset -> pull low for a whole period

start	clrf	counter
	clrf	counter+1
	movlw	17
	movwf	counter+2
	bsf	GPIO,0		; Mosfet on

loop	decfsz	counter
	goto	loop
	movlw	lowtime
	movwf	counter
	movlw	b'00000010'
	xorwf	GPIO
	decfsz	counter+1
	goto	loop
	decfsz	counter+2
	goto	loop

	bcf	GPIO,0	; Mosfet off

	movlw	40
	movwf	counter+1	; debounce

	movlw	3
	movwf	counter+1

loop2	decfsz	counter
	goto	loop2
	decfsz	counter+1
	goto	loop2

waitlow	btfsc	GPIO,4		; wait for ext. low-Pulse
	goto	waitlow
	goto	start		; gotcha - switch on


	end

